#include <owl\pch.h>
#include <owl\edit.h>
#include <owl\combobox.h>
#include <owl\validate.h>
#pragma hdrstop
#include "cbvalid.rh"

#define TEXT_SIZE  15

struct TValidBuffer {
	TComboBoxData cbData;
};


class TValidCombo: public TComboBox {
public:
	TValidCombo(TWindow* parent, int ResourceId,
		uint textLen = 0, TModule* module = 0);
protected:
private:
	TEdit *edit;
};

TValidCombo::TValidCombo(TWindow* parent, int ResourceId,
		uint textLen, TModule* module)
	: TComboBox(parent, ResourceId, textLen, module)
{
	edit = new TEdit(this, 1001, TEXT_SIZE);
	edit->SetValidator(new TPXPictureValidator("(###)###-####"));
}

///////////////////////////////////////////////////////////////////////////
class TTestDialog: public TDialog {
public:
	TTestDialog(TWindow* parent, TResId resId,
		TValidBuffer* buffer,	TModule* module = 0);
protected:
	void SetupWindow();
	void CmHelp();
	void CmOk();
private:
	TComboBox *comboBox;
DECLARE_RESPONSE_TABLE(TTestDialog);
};

DEFINE_RESPONSE_TABLE1(TTestDialog, TDialog)
	EV_COMMAND(IDOK, CmOk),
	EV_COMMAND(IDHELP, CmHelp),
END_RESPONSE_TABLE;


TTestDialog::TTestDialog(TWindow* parent, TResId resId,
		TValidBuffer* buffer, TModule* module)
	:	TDialog(parent, resId, module)
{
	comboBox = new TValidCombo(this, IDC_COMBOBOX1);
	SetTransferBuffer(buffer);
}


void TTestDialog::SetupWindow()
{
	TDialog::SetupWindow();

	if (comboBox->GetCount() == 0) {
		comboBox->AddString("(800)345-1518");
		comboBox->AddString("(800)950-1329");
		comboBox->AddString("(800)388-3228");
		comboBox->AddString("(800)922-8911");
		comboBox->AddString("(800)846-4526");
		comboBox->AddString("(800)426-3395");
		comboBox->AddString("(800)525-3019");
		comboBox->AddString("(800)245-0000");
		comboBox->AddString("(800)366-0476");
	}
	comboBox->SetSelIndex(-1);
}


void TTestDialog::CmHelp()
{
	MessageBox("Just enter your phone number.",
		"About Combo Box Validate");
}


void TTestDialog::CmOk()
{
	char buf[TEXT_SIZE];
	if (comboBox->GetText(buf, TEXT_SIZE) > 0)
		TDialog::CmOk();
	else
		MessageBeep(MB_ICONASTERISK);
}

///////////////////////////////////////////////////////////////////////////
class TWndw : public TFrameWindow
{
public:
	TWndw(TWindow *parent, const char far *title);
	~TWndw();
protected:
	void CmFileTest();
private:
	TValidBuffer buffer;  // Dialog transfer buffer
DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1(TWndw, TFrameWindow)
	EV_COMMAND(CM_FILETEST, CmFileTest),
END_RESPONSE_TABLE;


TWndw::TWndw(TWindow *parent, const char far *title)
	:	TFrameWindow(parent, title)
{
	AssignMenu(MENU_1);

	Attr.X = GetSystemMetrics(SM_CXSCREEN) / 8;
	Attr.Y = GetSystemMetrics(SM_CYSCREEN) / 8;
	Attr.H = Attr.Y * 6;
	Attr.W = Attr.X * 6;
}


TWndw::~TWndw()
{
}


void TWndw::CmFileTest()
{
	TDialog *dialog = new TTestDialog(this, DIALOG_1, &buffer);
	if (dialog->Execute() == IDOK) {
		char buf[TEXT_SIZE];
		buffer.cbData.GetSelString(buf, TEXT_SIZE);
		MessageBox(buf, "Your phone number is");
	}
}

///////////////////////////////////////////////////////////////////////////
class TApp : public TApplication
{
public:
	TApp(): TApplication() {}
	void InitMainWindow();
};


void TApp::InitMainWindow()
{
	TFrameWindow *wndw = new TWndw(0, "Combo Box Validate");
	SetMainWindow(wndw);
	EnableCtl3d();
}


int OwlMain(int /*argc*/, char* /*argv*/[])
{
	return TApp().Run();
}
